# we use the upstream version from http_parser.h as the SONAME
%define somajor 2
%define sominor 0

%define libname %mklibname %{name} %{somajor}
%define devname %mklibname -d %{name}

Name:           http-parser
Version:        2.9.2
Release:        %mkrel 1
Summary:        HTTP request/response parser for C
Group:          System/Libraries
License:        MIT
URL:            http://github.com/joyent/http-parser
Source0:	https://github.com/joyent/http-parser/archive/v%{version}/%{name}-%{version}.tar.gz
Patch1:		http-parser-gyp-sharedlib.patch
BuildRequires:	gyp

%description
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).

%package -n %{libname}
Summary:	A parser for HTTP messages written in C
Group:		System/Libraries

%description -n %{libname}
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).

%package -n %{devname}
Group:		Development/Libraries
Summary:	Development headers and libraries for http-parser
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{devname}
Development headers and libraries for http-parser.

%prep
%setup -q
%patch1 -p0

%build
# TODO: fix -fPIC upstream
export CFLAGS='%{optflags} -fPIC'
gyp -f make --depth=`pwd` http_parser.gyp
%make BUILDTYPE=Release

%install
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}

install -pm644 http_parser.h %{buildroot}%{_includedir}

#install regular variant
install out/Release/lib.target/libhttp_parser.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}.%{sominor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so

#install strict variant
install out/Release/lib.target/libhttp_parser_strict.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}.%{sominor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so

%check
export LD_LIBRARY_PATH='./out/Release/lib.target'
./out/Release/test-nonstrict
./out/Release/test-strict

%files -n %{libname}
%doc AUTHORS 
%{_libdir}/libhttp_parser.so.%{somajor}
%{_libdir}/libhttp_parser.so.%{somajor}.*
%{_libdir}/libhttp_parser_strict.so.%{somajor}
%{_libdir}/libhttp_parser_strict.so.%{somajor}.*

%files -n %{devname}
%{_includedir}/*
%{_libdir}/libhttp_parser.so
%{_libdir}/libhttp_parser_strict.so


%changelog
* Sun Apr 21 2019 tex 2.9.2-1pclos2019
- Update to version 2.9.2

